
import * as $calcit from "./calcit.core.mjs";
import { vec_add } from "./recollect.util.mjs";
var _tag={};
["assoc","dissoc","map-splice","set-splice","vec-append","vec-drop",].forEach(x => {
  _tag[x] = $calcit.newTag(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function patch_map(base, coord, removed, added) { 
if (arguments.length !== 4) throw _calcit_args_mismatch('patch-map', 4, arguments.length);

if ($calcit.empty_$q_(coord)) { return $calcit.merge($calcit.unselect_keys(base, removed), added) } else { return $calcit.update_in(base, coord, function f_PCT_(m) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.merge($calcit.unselect_keys(m, removed), added)
}
) }
}
export function patch_map_remove(base, coord, path) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('patch-map-remove', 3, arguments.length);

if ($calcit.empty_$q_(coord)) { return $calcit.dissoc(base, path) } else { return $calcit.update_in(base, coord, function f_PCT_(cursor) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.dissoc(cursor, path)
}
) }
}
export function patch_map_set(base, coord, data) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('patch-map-set', 3, arguments.length);

if ($calcit.empty_$q_(coord)) { return data } else { return $calcit.assoc_in(base, coord, data) }
}
export function patch_set(base, coord, removed, added) { 
if (arguments.length !== 4) throw _calcit_args_mismatch('patch-set', 4, arguments.length);

if ($calcit.empty_$q_(coord)) { return $calcit.union($calcit.difference(base, removed), added) } else { return $calcit.update_in(base, coord, function f_PCT_(cursor) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.union($calcit.difference(cursor, removed), added)
}
) }
}
export function patch_vector_append(base, coord, data) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('patch-vector-append', 3, arguments.length);
return $calcit.update_in(base, coord, function f_PCT_(cursor) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return vec_add(cursor, data)
}
)
}
export function patch_vector_drop(base, coord, data) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('patch-vector-drop', 3, arguments.length);
return $calcit.update_in(base, coord, function f_PCT_(cursor) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.slice(cursor, 0, data)
}
)
}
export function patch_one(base, change) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('patch-one', 2, arguments.length);

if ($calcit._$n__$e_($calcit.nth(change, 0), _tag["vec-append"])) { let coord = $calcit.nth(change, 1);
let data = $calcit.nth(change, 2);
return patch_vector_append(base, coord, data)
 }
 else if ($calcit._$n__$e_($calcit.nth(change, 0), _tag["vec-drop"])) { let coord = $calcit.nth(change, 1);
let data = $calcit.nth(change, 2);
return patch_vector_drop(base, coord, data)
 }
 else if ($calcit._$n__$e_($calcit.nth(change, 0), _tag["dissoc"])) { let coord = $calcit.nth(change, 1);
let data = $calcit.nth(change, 2);
return patch_map_remove(base, coord, data)
 }
 else if ($calcit._$n__$e_($calcit.nth(change, 0), _tag["assoc"])) { let coord = $calcit.nth(change, 1);
let data = $calcit.nth(change, 2);
return patch_map_set(base, coord, data)
 }
 else if ($calcit._$n__$e_($calcit.nth(change, 0), _tag["set-splice"])) { let coord = $calcit.nth(change, 1);
let removed = $calcit.nth(change, 2);
let added = $calcit.nth(change, 3);
return patch_set(base, coord, removed, added)
 }
 else if ($calcit._$n__$e_($calcit.nth(change, 0), _tag["map-splice"])) { let coord = $calcit.nth(change, 1);
let removed = $calcit.nth(change, 2);
let added = $calcit.nth(change, 3);
return patch_map(base, coord, removed, added)
 } else { console.error($calcit.printable("Unkown op:", change));
return base
 }
}
export let patch_twig = function patch_twig(base, changes) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('patch-twig', 2, arguments.length);
  
  let times_AUTO_3 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_2 = null;
    if (times_AUTO_3 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if ($calcit.empty_$q_(changes)) { ret_AUTO_2 =base } else { ret_AUTO_2 =$calcit.recur(patch_one(base, $calcit.first(changes)), $calcit.rest(changes)) }

    if (ret_AUTO_2 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_2.args.length !== 2) throw _calcit_args_mismatch('patch-twig', 2, ret_AUTO_2.args.length);
      [ base, changes ] = ret_AUTO_2.args;
      
      times_AUTO_3 += 1;
      continue;
    } else {
      return ret_AUTO_2;
    }
  }
}




